import java.util.Random;

boolean GESTARTET = false;

boolean SIEG_A = false;
boolean SIEG_B = false;

Sumo sumoA;
Sumo sumoB;
Integrator integratorA;
Integrator integratorB;

double sensorwertA=0.0;
double sensorwertB=0.0;

Sensor sensorA;
Sensor sensorB;

int[] FARBE_A = {255,200,200};
int[] FARBE_B = {200,255,200};

int[] FARBE_AA = {220,220,220};
int[] FARBE_BB = {220,220,220};

int[] FARBE_AS = {155,100,100};
int[] FARBE_BS = {100,155,100};

SensorGegner sensorGA;
SensorGegner sensorGB;

boolean KEYRELEASED = true;

double[] yA = new double[6];
double[] yA_alt = new double[6];
double[] yB = new double[6];
double[] yB_alt = new double[6];
double t = 0.0;
double dt = 0.001;  //Echtzeit
//double dt = 0.002;    //Doppelte Geschwindigkeit

float SKAL=0.0f,XOFF=0.0f,YOFF=0.0f;

Echtzeit echtzeit;

double TISCHDURCHMESSER = 0.85;

public void initialisieren()
{
  
    yA_alt[0] = 0.0;
    yA_alt[1] = -0.18;
    yA_alt[2] = 0.0;
    yA_alt[3] = 0.0;
    yA_alt[4] = 0.0;
    yA_alt[5] = 0.0;
    
    yB_alt[0] = 0.0;
    yB_alt[1] = 0.18;
    yB_alt[2] = Math.PI;
    yB_alt[3] = 0.0;
    yB_alt[4] = 0.0;
    yB_alt[5] = 0.0;

    sumoA.PWM_L = 0.0;
    sumoA.PWM_R = 0.0;
    sumoB.PWM_L = 0.0;
    sumoB.PWM_R = 0.0;

    
    try
    {
         Thread.sleep(2000);
    }
    catch(Exception e)
    {
    }
    
    GESTARTET = false;
}

public void setup()
{
    noFill();
    stroke(255);
    textSize(24.0f);
  
    SKAL = displayHeight/(float)TISCHDURCHMESSER; //Tischdurchmesser == Screenhöhe
  
    strokeWeight(displayHeight*0.01f);
  
    sumoA = new Sumo();
    integratorA = new Integrator(sumoA);
    sumoB = new Sumo();
    integratorB = new Integrator(sumoB);

    //Sensor(double[] yA, double[] yB, Sumo sumo)
    sensorA = new Sensor(yA_alt,null,sumoA);
    sensorB = new Sensor(yB_alt,null,sumoB);
    sensorGA = new SensorGegner(yA_alt,yB_alt,sumoA,sumoB);
    sensorGB = new SensorGegner(yB_alt,yA_alt,sumoB,sumoA);

    initialisieren();
    
    orientation(LANDSCAPE);
    
    echtzeit = new Echtzeit();
    
    frameRate(25);
    size(displayWidth, displayHeight);

//Test Antivalenz-Netz:    
    Netz netz = new Netz();
    netz.optimiereAntivalenz();
}

public void draw()
{
    
    clear();
    fill(0);
       
    rect(0,0,displayWidth,displayHeight);
    noFill();
    stroke(255);
    ellipse(displayWidth/2, displayHeight/2,displayHeight,displayHeight);
        
    
    //drawFahrzeug(Sumo sumo, double[] y_alt, int[] FARBE)
    drawFahrzeugFlaeche(sumoA,yA_alt,FARBE_AA);
    drawFahrzeugFlaeche(sumoB,yB_alt,FARBE_BB);
    drawFahrzeug(sumoA,yA_alt,FARBE_A);
    drawFahrzeug(sumoB,yB_alt,FARBE_B);
    
    sensorA.draw(FARBE_AS);
    sensorB.draw(FARBE_BS);
    sensorGA.draw(FARBE_AS);
    sensorGB.draw(FARBE_BS);

    fill(255,200,200);
    text(""+sensorA.holeSensorwert(),30,30);
    fill(200,255,200);
    text(""+sensorB.holeSensorwert(),30,80);
    
    fill(255,200,200);
    text(""+sensorGA.holeSensorwert(),30,130);
    fill(200,255,200);
    text(""+sensorGB.holeSensorwert(),30,180);
    
    fill(255,200,200);
    text(""+sensorwertA,30,330);
    fill(200,255,200);
    text(""+sensorwertB,30,380);

  
    if(SIEG_A==true)
    {
       fill(255,255,255);
       text("A ist Sieger",30,480);
    }
    else if(SIEG_B==true)
    {
       fill(255,255,255);
       text("B ist Sieger",30,480);
    }
    
    fill(255,255,0);
    noStroke();
}

public void keyPressed()
{
          Sumo sumo = sumoA;
  
          if(key==CODED)
          {
              if(keyCode==UP)
              {
               sumo.PWM_L = 799.0;
               sumo.PWM_R = 799.0;
                 if(GESTARTET==false)
                 {
                     GESTARTET = true;
                     SIEG_A = false;
                     SIEG_B = false;
                 }    
              }
              else if(keyCode==DOWN)
              {
               sumo.PWM_L = -799.0;
               sumo.PWM_R = -799.0;
                 if(GESTARTET==false)
                 {
                     GESTARTET = true;
                     SIEG_A = false;
                     SIEG_B = false;
                 }    
              }
              else if(keyCode==LEFT)
              {
               sumo.PWM_L = -799.0;
               sumo.PWM_R = 799.0;
                 if(GESTARTET==false)
                 {
                     GESTARTET = true;
                     SIEG_A = false;
                     SIEG_B = false;
                 }    
              }
              else if(keyCode==RIGHT)
              {
               sumo.PWM_L = 799.0;
               sumo.PWM_R = -799.0;
                 if(GESTARTET==false)
                 {
                     GESTARTET = true;
                     SIEG_A = false;
                     SIEG_B = false;
                 }    
              }
           }
}

public void keyReleased()
{
    Sumo sumo = sumoA;
  
    sumo.PWM_L = 0.0;
    sumo.PWM_R = 0.0;
}
