//Sensor vorn:
//RAND , Entfernung gemessen von der vorderen "Stoßstange"
//Entfernung/m   adw0
//0,530          86 indifferent
//0,430          89 indifferent
//0,320          89 indifferent
//0,250          67 o.k.
//0,160          56 o.k.
//0,075          70 Effekt dreht sich um!
//
//GEGNER
//Entfernung/m   adw0
//0,0 (Kontakt)  250
//0,09           175
//0,19           125
//0,265          118
//0,365           91
//0,540           83

public class SensorGegner
{
      double[] a,b,c,d;

      public boolean FAHRZEUG_DRINNEN = true; //merken, ob Fahrzeug noch in Arena ist
  
      public double[] yA; //Zustand y Sumo selbst als Referenz
      public double[] yB; //Zustand y Sumo Gegner als Referenz

      public Sumo sumo; //Irgendein Sumo-Objekt wegen der Parameter!
      public Sumo sumogegner; //Gegner Sumo
  
      public double wert=0.0; //Aktueller Sensorwert.
      public double abstand=0.0; //Aktueller Abstand vom Rand in Metern.

      public double[] PR = new double[2];  //Aktueller Randpunkt. (Schnittpunkt Gerade auf Stoßstange vorn zum Tischrand)
      public double[] PS = new double[2];  //Aktueller Stoßstangenpunkt
      public double[] eSR = new double[2];  //Richtungsvektor von PS nach PR
      public double[] eSG = new double[2];  //Richtungsvektor von PS nach PGegner
  
  
      public SensorGegner(double[] yA, double[] yB, Sumo sumo, Sumo sumogegner)
      {
          this.yA = yA;
          this.yB = yB;
          this.sumo = sumo;
          this.sumogegner = sumogegner;
          
          a = new double[2];
          b = new double[2];
          c = new double[2];
          d = new double[2];
      }
  
  
      //Entferunungs- Wertepaare, wenn der Sumo alleine auf dem Spielfeld ist:
//      double[][] allein = {{0.075,70.0},{0.160,56.0},{0.250,67.0},{0.32,89.0},{0.43,89.0},{0.53,86.0}};

//      double[][] gegner = {{0.0,250.0},{0.09,175.0},{0.19,125.0},{0.265,118.0},{0.365,91.0},{0.54,83.0}};
//umbenannt:
      double[][] allein = {{0.0,250.0},{0.09,175.0},{0.19,125.0},{0.265,118.0},{0.365,91.0},{0.54,83.0}};
 
      //a unterer Wert, x Wert zwischen a und b, b oberer Wert,
      //wa Ausgabewert bei a, wb Ausgabewert 
      public double interpoliere(double a, double x, double b, double wa, double wb)
      {
          double dist = b-a;
          double dist2 = wb-wa;
          
          double xx = x-a;
                              
          return wa + (dist2/dist)*xx;
      }
  
      public void berechne_abcd()
      {
          double x   = yA[0];
          double y   = yA[1];
          double phi = yA[2];
        
          a = transDouble(sumo.PA,x,y,phi);
          b = transDouble(sumo.PB,x,y,phi);
          c = transDouble(sumo.PC,x,y,phi);
          d = transDouble(sumo.PD,x,y,phi);
      }
  
      public void berechneStossstangenpunkt() //PS
      {
           //Mitte von A und B:
           PS[0] = 0.5*(a[0] + b[0]);            
           PS[1] = 0.5*(a[1] + b[1]);            
      }

      public void berechneRichtungsvektor()  //...von PS nach PR
      {
           double laenge = Math.sqrt(    (a[0]-d[0])*(a[0]-d[0]) + 
                                         (a[1]-d[1])*(a[1]-d[1])
                                    );
                                    
           eSR[0] =   (a[0]-d[0])/laenge;                                  
           eSR[1] =   (a[1]-d[1])/laenge;                                  
      }
      
      public void berechneRandpunkt() //PR
      {
           FAHRZEUG_DRINNEN = true;
           abstand = Math.sqrt((PS[0]-yB[0])*(PS[0]-yB[0])+(PS[1]-yB[1])*(PS[1]-yB[1])); 
           //Einfach Mitte von Gegnerfahrzeug nehmen:
           PR[0] = yB[0];
           PR[1] = yB[1];
       
           //Wenn Skalarprodukt zwischen Richtungsvektor in Sensorrichtung eSR und Verbindungsvektor zu Gegner
           //einen Winkel von 20 Grad überschreitet, dann nichts sichtbar!
           eSG[0] =   (yB[0]-PS[0])/abstand;                                  
           eSG[1] =   (yB[1]-PS[1])/abstand;                                  

           double skalarprodukt = eSG[0]*eSR[0]+eSG[1]*eSR[1];
           //Skalarprodukt == Cosinus eingeschl. Winkel.
           if(skalarprodukt>0.8) //cos 30Grad == 0.866
               FAHRZEUG_DRINNEN = true;
           else
               FAHRZEUG_DRINNEN = false;
           
           
      }

      public void berechneSensorwert()
      {
          //abstand ist jetzt bestimmt, nun muß Interpolation angewendet werden:
          
          //1. kleiner kleinster Wert:
          if(abstand<=allein[0][0])
          {
              wert = allein[0][1];
          }
          //2. Größer als größter:
          else if(abstand>=allein[allein.length-1][0])
          {
              wert = allein[allein.length-1][1];
          }
          //3. dazwischen:
          else
          {
              wert = allein[allein.length-1][1];
              for(int i=1;i<allein.length;i++)
              {
                    
                    if(abstand<=allein[i][0])
                    {
                        //wert = interpoliere(double a, double x, double b, double wa, double wb);
                          wert = interpoliere(allein[i-1][0],abstand,allein[i][0],allein[i-1][1],allein[i][1]);
                        break;  
                    }
              }
          }
      }
  
      public void aktualisieren()
      {
          berechne_abcd();        
          berechneStossstangenpunkt();
          berechneRichtungsvektor();
          berechneRandpunkt();  
          berechneSensorwert();
      }
      
      public void draw(int[] FARBE) //Verbindungslinie einzeichnen
      {
            if(FAHRZEUG_DRINNEN==true)
            {
                float[] pr = new float[2];                 
                float[] ps = new float[2];

                pr[0] = (float)PR[0];
                pr[1] = (float)PR[1];
                ps[0] = (float)PS[0];
                ps[1] = (float)PS[1];
                
                //v[1] = -v[1];
      
                //v[0]*=SKAL;
                //v[1]*=SKAL;
      
                //v[0]+=displayWidth/2.0f;
                //v[1]+=displayHeight/2.0f;
                
                pr[1]=-pr[1];
                ps[1]=-ps[1];
                
                pr[0]*=SKAL;
                pr[1]*=SKAL;
                ps[0]*=SKAL;
                ps[1]*=SKAL;
                
                pr[0]+=displayWidth/2.0f;
                pr[1]+=displayHeight/2.0f;
                ps[0]+=displayWidth/2.0f;
                ps[1]+=displayHeight/2.0f;
                
                noFill();
                stroke(FARBE[0],100+FARBE[1],FARBE[2]);
                
                line(ps[0],ps[1],pr[0],pr[1]);
                stroke(255);
            }            
      }
      
      public double holeSensorwert()
      {
            return wert;
      }
      
      public double[] holeRandpunkt()
      {
            return PR;
      }
      public double[] holeStossstangenpunkt()
      {
            return PS;
      }
}
